package com.ruoyi.system.service;

import java.util.List;
import com.ruoyi.system.domain.UrYearValidData;
import com.ruoyi.system.domain.vo.UrYearValidDataVo;

/**
 * 专利有效按年统计结果Service接口
 * 
 * @author dm
 * @date 2023-02-12
 */
public interface IUrYearValidDataService 
{
    /**
     * 查询专利有效按年统计结果
     * 
     * @param id 专利有效按年统计结果主键
     * @return 专利有效按年统计结果
     */
    public UrYearValidData selectUrYearValidDataById(Long id);

    /**
     * 查询专利有效按年统计结果列表
     * 
     * @param urYearValidData 专利有效按年统计结果
     * @return 专利有效按年统计结果集合
     */
    public List<UrYearValidData> selectUrYearValidDataList(UrYearValidDataVo urYearValidData);

    /**
     * 新增专利有效按年统计结果
     * 
     * @param urYearValidData 专利有效按年统计结果
     * @return 结果
     */
    public int insertUrYearValidData(UrYearValidData urYearValidData);

    /**
     * 修改专利有效按年统计结果
     * 
     * @param urYearValidData 专利有效按年统计结果
     * @return 结果
     */
    public int updateUrYearValidData(UrYearValidData urYearValidData);

    /**
     * 批量删除专利有效按年统计结果
     * 
     * @param ids 需要删除的专利有效按年统计结果主键集合
     * @return 结果
     */
    public int deleteUrYearValidDataByIds(Long[] ids);

    /**
     * 删除专利有效按年统计结果信息
     * 
     * @param id 专利有效按年统计结果主键
     * @return 结果
     */
    public int deleteUrYearValidDataById(Long id);

    /**
     * 批量删除---逻辑删除
     *
     * @param ids 需要删除的专利有效按年统计结果ID
     * @return 结果
     */
    public int setDeleteByIds(Long[] ids);

    /**
     * 删除---逻辑删除
     *
     * @param id 专利有效按年统计结果ID
     * @return 结果
     */
    public int setDeleteById(Long id);

    /**
     * 获取有效概览左侧表头列表
     * @return
     */
    public List<UrYearValidData> selectUrLeftList();

    /**
     * 查询云南省专利有效按年统计结果列表
     *
     * @param urYearValidData 专利有效按年统计结果
     * @return 云南省专利有效按年统计结果集合
     */
    public List<UrYearValidData> selectUrYearValidDataProvinceList(UrYearValidDataVo urYearValidData);

    /**
     * 查询有效概览里需要的最新有效数据所在年
     * @return
     */
    public List<String> selectYearList();
}
